from rest_framework import status
from rest_framework.test import APITestCase

# Tests new registration, boundary values and 2-way domain
class RegistrationTestCase(APITestCase):
    def test_boundaryValuesOfRegistrationInvalid(self):
        data = {"username": "test", "email": "", 
                "password": "", "password1": "", 
                "phone_number": "", "country": "",
                "city": "", "street_address": ""}
        response = self.client.post("/api/users/", data)
        self.assertEqual(response.status_code, status.HTTP_400_BAD_REQUEST) #should fail at blank pwd

        data = {"username": "", "email": "", 
                "password": "1", "password1": "1", 
                "phone_number": "", "country": "",
                "city": "", "street_address": ""}
        response = self.client.post("/api/users/", data)
        self.assertEqual(response.status_code, status.HTTP_400_BAD_REQUEST) #should fail at blank username

        # Seem to be no upper value and no restrictions to the other fields

    def test_boundaryValuesOfRegistrationValid(self):
        data = {"username": "t", "email": "", 
                "password": "1", "password1": "1", 
                "phone_number": "", "country": "",
                "city": "", "street_address": ""}
        response = self.client.post("/api/users/", data)
        self.assertEqual(response.status_code, status.HTTP_201_CREATED) #should work at one char pwd and username

    def test_domainRegistration(self):
        "2-way domain tests to test the register page"


# Tests new functionality in UC-2
class Statistics(APITestCase):
    def test_renderStatistics(self):
        "test that the statistics are rendered"

    def test_correctStatistics(self):
        "Check that statistics are correctly calculated"

