import json

from django.contrib.auth.models import User
from django.urls import reverse
from rest_framework import status
from rest_framework.authtoken.models import Token
from rest_framework.test import APITestCase

from users.serializers import UserSerializer
from workouts.serializers import WorkoutSerializer
from workouts.models import Workout


# Tests new workout and boundary values
class NewWorkoutTestCase(APITestCase):
    # Følger denne: https://www.youtube.com/watch?v=1FqxfnlQPi8&ab_channel=pymike00
    # men skjønner ikke helt feilmeldinga som kommer nå, setup funker ikke
    
    def setUp(self):
        self.user = User.objects.create_user(username="test",
                                             password="strong_pwd")
        self.token = Token.object.create(user=self.user)
        self.api_authentication()

    def api_authentication(self):
        self.client.credentials(HTTP_AUTHORIZATION="Token " + self.token.key)

    def test_newWorkoutRegistration(self):
        data = {"name": "test", "date": "2019-09-25 06:00", 
                "notes": "test", "owner": "", 
                "visibility": "Public"}
        response = self.client.post("/api/workouts/", data)
        self.assertEqual(response.status_code, status.HTTP_201_CREATED) #should work

    def test_boundaryValuesOfNewWorkout(self):
        "test boundary values of new workout"

# Tests FR5
class WorkoutDetails(APITestCase):
    def test_viewDetails(self):
        "Test that user can view all details"

    def test_viewFiles(self):
        "Test that user can view all files"

    def test_viewComments(self):
        "Test that user can view all comments"

# Tests new functionality in UC-3 and UC-4
class Categories(APITestCase):
    def test_categorizeExercise(self):
        "test that categorizing exercise works"

    def test_sortExercise(self):
        "test that sorting exercise works"

# Tests new functionality in UC-1
class NewWorkoutAsCoach(APITestCase):
    def test_createWorkoutAsCoach(self):
        "Check that a workout can be created as a coach"